import { CodegenModuleMeta } from "./codegen/codegenHelpers";
export declare const OneGraphNetlifyCliSessionTestEventSdl = "type OneGraphNetlifyCliSessionTestEvent {\n  id: String!\n  sessionId: String!\n  createdAt: String!\n  payload: JSON!\n}";
export declare type OneGraphNetlifyCliSessionTestEvent = {
    __typename: "OneGraphNetlifyCliSessionTestEvent";
    id: string;
    sessionId: string;
    createdAt: string;
    payload: Record<string, unknown>;
};
export declare const OneGraphNetlifyCliSessionGenerateHandlerEventSdl = "type OneGraphNetlifyCliSessionGenerateHandlerEvent {\n  id: String!\n  sessionId: String!\n  createdAt: String!\n  payload: {\n    cliSessionId: String!\n    operationId: String\n    codegenId: String!\n    options: JSON\n  }\n}";
export declare type OneGraphNetlifyCliSessionGenerateHandlerEvent = {
    __typename: "OneGraphNetlifyCliSessionGenerateHandlerEvent";
    id: string;
    sessionId: string;
    createdAt: string;
    payload: {
        cliSessionId: string;
        operationId: string;
        codegenId: string;
        options?: Record<string, unknown> | null;
    };
};
export declare const OneGraphNetlifyCliSessionOpenFileEventSdl = "type OneGraphNetlifyCliSessionOpenFileEvent {\n  id: String!\n  sessionId: String!\n  createdAt: String!\n  payload: {\n    filePath: String!\n  }\n}";
export declare type OneGraphNetlifyCliSessionOpenFileEvent = {
    __typename: "OneGraphNetlifyCliSessionOpenFileEvent";
    id: string;
    sessionId: string;
    createdAt: string;
    payload: {
        filePath: string;
    };
};
export declare const OneGraphNetlifyCliSessionPersistedLibraryUpdatedEventSdl = "type OneGraphNetlifyCliSessionPersistedLibraryUpdatedEvent {\n    id: String!\n    sessionId: String!\n    createdAt: String!\n    payload: {\n      docId: String!\n      schemaId: String!\n    }\n  }";
export declare type OneGraphNetlifyCliSessionPersistedLibraryUpdatedEvent = {
    __typename: "OneGraphNetlifyCliSessionPersistedLibraryUpdatedEvent";
    id: string;
    sessionId: string;
    createdAt: string;
    payload: {
        docId: string;
        schemaId: string;
    };
};
export declare const OneGraphNetlifyCliSessionFilesWrittenFileSdl = "type OneGraphNetlifyCliSessionFilesWrittenFile {\n  name: String\n  \"\"\"\n  OS-dependent file path\n  \"\"\"\n  filePath: String!\n}";
export declare type OneGraphNetlifyCliSessionFilesWrittenFile = {
    __typename: "OneGraphNetlifyCliSessionFilesWrittenFile";
    name: string;
    /**
     * OS-dependent file path
     */
    filePath: string;
};
export declare const OneGraphNetlifyCliSessionFilesWrittenEventSdl = "type OneGraphNetlifyCliSessionFilesWrittenEvent {\n    id: String!\n    sessionId: String!\n    createdAt: String!\n    payload: {\n      editor: String\n      files: [OneGraphNetlifyCliSessionFilesWrittenFile!]!\n    }\n    audience: String!\n}";
export declare type OneGraphNetlifyCliSessionFilesWrittenEvent = {
    __typename: "OneGraphNetlifyCliSessionFilesWrittenEvent";
    id: string;
    sessionId: string;
    createdAt: string;
    payload: {
        editor: string | null;
        files: OneGraphNetlifyCliSessionFilesWrittenFile[];
    };
    audience: "UI" | "CLI";
};
export declare const OneGraphNetlifyCliSessionCodegenHandlerFunctionOptionsSdl = "type OneGraphNetlifyCliSessionCodegenHandlerFunctionOptions {\n    schemaSdl: String!\n    inputTypename: String!\n    defaultValue: JSON\n}";
export declare const OneGraphNetlifyCliSessionCodegenSupportedDefinitionTypesEnumSdl = "enum OneGraphNetlifyCliSessionCodegenSupportedDefinitionTypesEnum {\n    QUERY\n    MUTATION\n    SUBSCRIPTION\n    FRAGMENT\n}";
export declare const OneGraphNetlifyCliSessionCodegenMetadataSdl = "type OneGraphNetlifyCliSessionCodegenMetadata {\n    id: String!\n    name: String!\n    operations: OneGraphNetlifyCliSessionCodegenHandlerFunctionOptions\n    supportedDefinitionTypes: [OneGraphNetlifyCliSessionCodegenSupportedDefinitionTypesEnum!]!\n}";
export declare const OneGraphNetlifyCliSessionCodegenModuleMetadataSdl = "type OneGraphNetlifyCliSessionCodegenModuleMetadata {\n    id: String!\n    version: String!\n    generators: [OneGraphNetlifyCliSessionCodegenMetadata!]!\n}";
export declare const OneGraphNetlifyCliSessionMetadataPublishEventSdl = "type OneGraphNetlifyCliSessionMetadataPublishEvent {\n    id: String!\n    sessionId: String!\n    createdAt: String!\n    payload: {\n      editor: String\n      siteRoot: String\n      siteRootFriendly: String\n      schemaId: String!\n      persistedDocId: String!\n      codegenModule: OneGraphNetlifyCliSessionCodegenModuleMetadata\n      platform: String\n      arch: String\n      nodeVersion: String\n      framework: String\n    }\n    audience: String!\n}";
export declare type cliSessionMetadata = {
    cliVersion: string;
    editor: string | null;
    siteRoot: string | null;
    siteRootFriendly: string | null;
    schemaId: string;
    persistedDocId: string;
    codegenModule: CodegenModuleMeta | null;
    platform: string | null;
    arch: string | null;
    nodeVersion: string | null;
    framework: string | null;
};
export declare type OneGraphNetlifyCliSessionMetadataPublishEvent = {
    __typename: "OneGraphNetlifyCliSessionMetadataPublishEvent";
    id: string;
    sessionId: string;
    createdAt: string;
    payload: cliSessionMetadata;
    audience: "UI";
};
export declare const OneGraphNetlifyCliSessionMetadataRequestEventSdl = "type OneGraphNetlifyCliSessionMetadataRequestEvent {\n    id: String!\n    sessionId: String!\n    createdAt: String!\n    payload: {\n        minimumCliVersionExpected: String!\n        expectedAudience: String!\n    }\n    audience: String!\n}";
export declare type OneGraphNetlifyCliSessionMetadataRequestEvent = {
    __typename: "OneGraphNetlifyCliSessionMetadataRequestEvent";
    id: string;
    sessionId: string;
    createdAt: string;
    payload: {
        minimumCliVersionExpected: string;
        expectedAudience: "UI";
    };
    audience: "CLI";
};
export declare const OneGraphNetlifyCliSessionSetGraphCodegenModuleEventSdl = "type OneGraphNetlifyCliSessionSetGraphCodegenModuleEvent {\n    id: String!\n    sessionId: String!\n    createdAt: String!\n    payload: {\n        codegenModuleImportPath: String!\n    }\n    audience: String!\n}";
export declare type OneGraphNetlifyCliSessionSetGraphCodegenModuleEvent = {
    __typename: "OneGraphNetlifyCliSessionSetGraphCodegenModuleEvent";
    id: string;
    sessionId: string;
    createdAt: string;
    payload: {
        codegenModuleImportPath: string;
    };
    audience: "CLI";
};
export declare type CliEvent = OneGraphNetlifyCliSessionTestEvent | OneGraphNetlifyCliSessionGenerateHandlerEvent | OneGraphNetlifyCliSessionOpenFileEvent | OneGraphNetlifyCliSessionPersistedLibraryUpdatedEvent | OneGraphNetlifyCliSessionFilesWrittenEvent | OneGraphNetlifyCliSessionMetadataPublishEvent | OneGraphNetlifyCliSessionMetadataRequestEvent | OneGraphNetlifyCliSessionSetGraphCodegenModuleEvent;
export declare type DetectedLocalCLISessionMetadata = {
    gitBranch: string | null;
    hostname: string | null;
    username: string | null;
    siteRoot: string | null;
    cliVersion: string;
    editor: string | null;
    codegen: CodegenModuleMeta | null;
    platform: string | null;
    arch: string | null;
    nodeVersion: string | null;
    framework: string | null;
};
