"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createLockfile = exports.hashOperations = exports.defaultLockFileName = void 0;
// Rusha gives us a SHA1 (good enough for file content hashing) and was already
// present in the Netlify React UI JS bundle when we introduced lockfiles
var rusha_1 = require("rusha");
exports.defaultLockFileName = "netlifyGraph.lock";
var hashOperations = function (operationsDoc) {
    return (0, rusha_1.createHash)().update(operationsDoc).digest("hex");
};
exports.hashOperations = hashOperations;
var createLockfile = function (_a) {
    var schemaId = _a.schemaId, operationsFileContents = _a.operationsFileContents;
    var operationsHash = (0, exports.hashOperations)(operationsFileContents);
    return {
        version: "v0",
        locked: {
            schemaId: schemaId,
            operationsHash: operationsHash,
        },
    };
};
exports.createLockfile = createLockfile;
//# sourceMappingURL=lockfile.js.map